//Direct granules extruder
//https://homofaciens.de/technics-machines-3D-printer-Granule-Extruder_ge.htm

thread_d = 4.2;
nail_d = 3.2;
M4_hole = 4.2;
M4_head = 8;
M3_hole = 3.3;
$fn=200;
alu_edge = 16;
motor_e = 42;
motor_l = 40;
motor_m = 31;

bowl_d = 70;
bowl_h = 65;
bowl_wall = 3;

//Motor mount
mm_r = 22;
mm_d1 = motor_e + 15;
mm_d2 = motor_l - 5;
motor_m = 31;

//Ball bearing
bb_do = 22;
bb_di = 8;
bb_w = 7;

extuder_m_x = 60;

//bowl();

//translate([0, -15-5, 39.5+alu_edge/2]){
//  rotate([270, 0, 180]){
//    mount_plate();
//  }
//}

/*
translate([0, 0, 69.0]){
  cube(size=[90, alu_edge, alu_edge], center=true);
  translate([30, 0, 0]){
    rotate([90, 0, 0]){
      cylinder(d=M4_hole, h=60, center=true);
    }
  }
}
translate([0, 0, 69+alu_edge+1]){
  cube(size=[90, alu_edge, alu_edge], center=true);
  translate([30, 0, 0]){
    rotate([90, 0, 0]){
      cylinder(d=M4_hole, h=60, center=true);
    }
  }
}
*/

//translate([-48, 0, 54]){
//  rotate([0, 90, 0]){
//    fan_mount();
//    translate([0, -5, 0]) mirror([0, 1, 0]) fan_mount();
//  }
//}


//translate([0, -23, -30]){
//  rotate([0, 90, 90]){
//    motor_mount();
//  }
//}

motor_coupler(1);


//cold_end();

module cold_end(){
  
  translate([0, 0, alu_edge/2]){
    difference(){
      translate([alu_edge/4, 0, 0]){
        cube(size=[alu_edge/2, 70, alu_edge], center=true);
      }
      cylinder(d1=10, d2=6, h=alu_edge*1.1, center=true);
    }
  }
  
  
}

module motor_coupler(part=0){
  mci_d = 19.5;
  mci_d2 = 12;
  mci_h = 7;
  mci_cut_l = 11;
  mci_cut_a = -10;
  
  mco_d = 25;
  mco_wall = 2;
  mco_wall2 = 9;
  mco_h = 27;
  mco_shaft = 5;
  mco_shaft_shift = 4.5;

  shaft_d = 3;
  shaft_d2 = 3.5;
  
  if(part==0 || part==1){
    //Inner part
    translate([0, 0, mci_h/2]){
      difference(){
        cylinder(d=mci_d, h=mci_h, center=true);
        cylinder(d=3.2, h=mci_h*1.1, center=true);
          for(i=[0:90:90]){
            rotate([0, 0, i]){
              rotate([90, 0, 0]){
                cylinder(d=shaft_d, h=mco_d*1.1, center=true);
              }
            }
          }
      }
    }
  }

  if(part==0 || part==2){
    //Outer part  
    translate([(mci_d + mco_d)/2+3, 0, mco_h/2]){
      difference(){
        cylinder(d=mco_d, h=mco_h, center=true);
        // Retract slits
        translate([0, 0, 8]){
          for(i=[0:180:270]){
            rotate([0, 0, i]){
              // +-mci_d/2 to mirror pitch
              translate([-mci_d/2, 0, 0]){
                rotate([mci_cut_a, 0, 0]){
                  cube(size=[mci_d, mci_cut_l, shaft_d2], center=true);
                  translate([0, mci_cut_l/2]){
                    rotate([0, 90, 0]){
                      cylinder(d=shaft_d2, h=mci_d, center=true);
                    }
                  }
                  translate([0, -mci_cut_l/2]){
                    rotate([0, 90, 0]){
                      cylinder(d=shaft_d2, h=mci_d, center=true);
                    }
                  }
                }
              }
            }
          }
        }
        // No retract hole
        translate([0, 0, 8]){
          rotate([0, 90, 90]){
            cylinder(d=shaft_d2, h=mco_d*10, center=true);
          }
        }
        // Center hole stepper motor shaft
        translate([0, 0, mco_wall2]){
          cylinder(d=mco_d-2*mco_wall, h=mco_h, center=true);
        }
        translate([0, 0, -(mco_h-mco_wall2)/2-2]){
          difference(){
            cylinder(d=mco_shaft, h=mco_wall2, center=true);
            translate([0, mco_shaft_shift, 0]){
              cube(size=[mco_shaft, mco_shaft, mco_wall2], center=true);
            }
          }
        }
      }
    }
  }
  
}

module motor_coupler_2(){
  mci_d = 16;
  mci_d2 = 12;
  mci_h = 7;
  mci_cut_l = 6.5;
  mci_cut_a = -10;
  
  mco_d = 30;
  mco_wall = 5;
  mco_wall2 = 7;
  mco_h = 20;
  mco_shaft = 5;
  mco_shaft_shift = 4.5;

  shaft_d = 3;
  shaft_d2 = 3.3;
  
  //Inner part
  translate([0, 0, mci_h/2]){
    difference(){
      cylinder(d=mci_d, h=mci_h, center=true);
      cylinder(d=M3_hole, h=mci_h*1.1, center=true);
      difference(){
        union(){
          for(i=[0:90:270]){
            rotate([0, 0, i]){
              translate([mci_d/2, 0, 0]){
                rotate([mci_cut_a, 0, 0]){
                  cube(size=[mci_d, mci_cut_l, shaft_d2], center=true);
                  translate([0, mci_cut_l/2]){
                    rotate([0, 90, 0]){
                      cylinder(d=shaft_d2, h=mci_d, center=true);
                    }
                  }
                  translate([0, -mci_cut_l/2]){
                    rotate([0, 90, 0]){
                      cylinder(d=shaft_d2, h=mci_d, center=true);
                    }
                  }
                }
              }
            }
          }
        }
        cylinder(d=mci_d2, h=mci_h*1.1, center=true);
      }
    }
  }

  //Outer part  
  translate([(mci_d + mco_d)/2+3, 0, mco_h/2]){
    difference(){
      cylinder(d=mco_d, h=mco_h, center=true);
      translate([0, 0, 6]){
        for(i=[0:90:90]){
          rotate([0, 0, i]){
            rotate([90, 0, 0]){
              cylinder(d=shaft_d, h=mco_d*1.1, center=true);
            }
          }
        }
      }
      translate([0, 0, mco_wall2]){
        cylinder(d=mco_d-2*mco_wall, h=mco_h, center=true);
      }
      difference(){
        cylinder(d=mco_shaft, h=mco_h*1.1, center=true);
        translate([0, mco_shaft_shift, 0]){
          cube(size=[mco_shaft, mco_shaft, mco_h], center=true);
        }
      }
    }
    
  }
  
}

module motor_mount(){
  mm_wall = 3;
  mm_w = 42;
  mm_l = bowl_d;
  mm_h = 90-bowl_h;
  mm_center_1 = 30;
  mm_center_2 = 35;
  mm_distance = 55;
  mount_shift = 2;
  
  mm_h2 = 10;
  mm_w2 = mm_w + 5;
  
  //Mount plate on motor side
  translate([30, 0, 0]){
    difference(){
      union(){
        roundedRect(size=[mm_w2, mm_l, mm_wall], radius=5);
        translate([mm_w2/2, 0, mm_h2/2]){
          rotate([0, 90, 0]){
            roundedRect(size=[mm_h2, mm_l-10, mm_wall], radius=5, edges=[1,0,1,0]);
          }
        }
        translate([-mm_wall-mm_w2/2, 0, mm_h2/2]){
          rotate([0, 90, 0]){
            roundedRect(size=[mm_h2, mm_l-10, mm_wall], radius=5, edges=[1,0,1,0]);
          }
        }
      }
      
      //Motor center hole
      translate([0, 0, mm_wall/2]){
        cylinder(d=mm_center_1, h=mm_wall*1.1, center=true);
      }

      //Motor mount plate holes
      translate([motor_m/2, mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, -mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([motor_m/2, -mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }

      //Motor mount holes
      translate([motor_m/2, motor_m/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, motor_m/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, -motor_m/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([motor_m/2, -motor_m/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
    }
  }
  
  //Mount on top of bowl
  translate([0, 0, mm_w/2])
  rotate([0, -90, 0])
  difference(){
    union(){
      roundedRect(size=[mm_w, mm_l, mm_h], radius=5);
    }
    translate([0, 0, mm_wall]){
      roundedRect(size=[mm_w-mm_wall*2, mm_l-mm_wall*2, mm_h-mm_wall*2], radius=5);
    }
    translate([mm_w/2, 0, mm_h/2]){
      cube(size=[mm_w, mm_l-mm_wall*2, mm_h-mm_wall*2], center=true);
    }
    translate([mount_shift, 0, 0]){
      //Bowl center hole
      translate([0, 0, mm_h-mm_wall/2]){
        cylinder(d=mm_center_2, h=mm_wall*1.1, center=true);
      }
      translate([mm_w/2, 0, mm_h-mm_wall/2]){
        cube(size=[mm_w, 35, mm_wall*1.1], center=true);
      }
      translate([mm_w/2, 0, mm_h-mm_wall/2]){
        rotate([0, 0, 45])
        cube(size=[44, 44, mm_wall*1.1], center=true);
      }

      //Motor center hole
      translate([0, 0, mm_wall/2]){
        cylinder(d=mm_center_1, h=mm_wall*1.1, center=true);
        translate([0, mm_center_1/2-2, 0]){
          cylinder(d=12, h=mm_wall*1.1, center=true);
        }
        translate([0, -mm_center_1/2+2, 0]){
          cylinder(d=12, h=mm_wall*1.1, center=true);
        }
      }

      //Bowl mount holes
      translate([0, mm_r, mm_h-mm_wall/2]){
        cylinder(d=M4_hole, h=mm_wall*1.1, center=true);
      }
      translate([0, -mm_r, mm_h-mm_wall/2]){
        cylinder(d=M4_hole, h=mm_wall*1.1, center=true);
      }
      
      //Motor mount holes
      translate([motor_m/2, mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([-motor_m/2, -mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
      translate([motor_m/2, -mm_distance/2, mm_wall/2]){
        cylinder(d=M3_hole, h=mm_wall*1.1, center=true);
      }
    }
  }
  
  
}

module fan_mount(){
  fan_w = 40;
  fan_holes = 32.5;
  
  fm_w = 46;
  fm_h = 46;
  fm_wall = 13;
  fm_shift = 0;
  
  tunnel_shift = 0;
  tunnel_l = bowl_d+2*fm_wall+tunnel_shift;
  tunnel_h = 20;
  tunnel_wall = 3;
  tunnel_w = fan_w - (alu_edge+2*bowl_wall)-2*tunnel_wall;
  
  difference(){
    union(){
      roundedRect(size=[fm_w, fm_h, fm_wall], radius=5, edges=[1,1,0,0]);
      translate([-(fm_w-tunnel_h)/2, (fm_w-tunnel_wall)/2, tunnel_l/2]){
        cube(size=[tunnel_h, tunnel_wall, tunnel_l], center=true);
      }
      translate([(tunnel_wall-fm_w)/2, (fm_w-tunnel_w)/2-1.5, tunnel_l/2]){
        cube(size=[tunnel_wall, tunnel_w+bowl_wall, tunnel_l], center=true);
      }
      translate([tunnel_h-(fm_w+tunnel_wall)/2, (fm_w-tunnel_w)/2-fm_shift, tunnel_l/2+15]){
        cube(size=[tunnel_wall, tunnel_w-1, tunnel_l-30], center=true);
      }
      difference(){
        translate([-3, fm_w/2, fm_wall]){
          rotate([90, 0, 0]){
            linear_extrude(height=tunnel_w){
              x1=-tunnel_wall;
              y1=0;
              x2=fm_w-tunnel_h;
              y2=0;
              x3=-tunnel_wall;
              y3=20;
              polygon(points=[[x1,y1],[x2,y2],[x3,y3]]);
            }
          }
        }
        translate([-5-tunnel_wall, fm_w/2-tunnel_wall, fm_wall]){
          rotate([90, 0, 0]){
            linear_extrude(height=tunnel_w+tunnel_wall){
              x1=-tunnel_wall;
              y1=0;
              x2=fm_w-tunnel_h;
              y2=0;
              x3=-tunnel_wall;
              y3=20;
              polygon(points=[[x1,y1],[x2,y2],[x3,y3]]);
            }
          }
        }
      }
    }
    //Cut left half
    translate([0, -fm_w/2, fm_wall/2]){
      cube(size=[fm_w*1.1, fm_h, fm_wall*1.1], center=true);
    }
    
    //Center hole
    translate([0, -fm_shift, fm_wall/2]){
      cylinder(d=40, h=fm_wall*1.1, center=true);
    }
    //Mount mount holes
    translate([(alu_edge-fm_w)/2, 0, tunnel_shift/2+(tunnel_l-extuder_m_x)/2]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=fm_w*2.1, center=true);
      }
    }
    translate([(alu_edge-fm_w)/2, 0, tunnel_shift/2+(tunnel_l+extuder_m_x)/2]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=fm_w*2.1, center=true);
      }
    }
    
    //Fan mount holes
    translate([fan_holes/2, fan_holes/2-fm_shift, fm_wall/2]){
      cylinder(d=3, h=fm_wall*1.1, center=true);
    }
    translate([-fan_holes/2, fan_holes/2-fm_shift, fm_wall/2]){
      cylinder(d=3, h=fm_wall*1.1, center=true);
    }
    translate([-fan_holes/2, -fan_holes/2-fm_shift, fm_wall/2]){
      cylinder(d=3, h=fm_wall*1.1, center=true);
    }
    translate([fan_holes/2, -fan_holes/2-fm_shift, fm_wall/2]){
      cylinder(d=3, h=fm_wall*1.1, center=true);
    }
  }
  
  
  
  
}

module mount_plate(){
  mp_w = 70;
  mp_w1 = 40;
  mp_h = 87;
  mp_h1 = 50;
  mp_wall = 5;
  mp_shift = 10;
  
  //Position mount holes Zonestar P802
  mp_x1 = 36;
  mp_y1 = 7;
  mp_x2 = 0;
  mp_y2 = 46+mp_y1;
  
  //Position mount holes aluminum square extruder
  mp_x3 = extuder_m_x;
  mp_y3 = 15 + mp_y1;

  //Position mount hole bowl
  mp_x4 = 0;
  mp_y4 = mp_y3 + 68 - alu_edge/2;
  
  translate([0, 0, 0]){
    difference(){
      union(){
        translate([0, (mp_h1-mp_h)/2, 0]){
          roundedRect(size=[mp_w, mp_h1, mp_wall], radius=5);
        }
        translate([0, (mp_h-(mp_h-mp_h1))/2, 0]){
          roundedRect(size=[mp_w1, mp_h-mp_h1, mp_wall], radius=5, edges=[0,0,1,1], angle=180);
        }
        translate([mp_x1/2, mp_y1-mp_h/2, mp_wall+mp_shift/2]){
          cylinder(d=M4_hole*3, h=mp_shift, center=true);
        }
        translate([-mp_x1/2, mp_y1-mp_h/2, mp_wall+mp_shift/2]){
          cylinder(d=M4_hole*3, h=mp_shift, center=true);
        }
        translate([0, mp_y2-mp_h/2, mp_wall+mp_shift/2]){
          cylinder(d=M4_hole*3, h=mp_shift, center=true);
        }
      }
      translate([mp_x1/2, mp_y1-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=50, center=true);
      }
      translate([-mp_x1/2, mp_y1-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=50, center=true);
      }
      translate([0, mp_y2-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=50, center=true);
      }
      translate([mp_x3/2, mp_y3-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=mp_wall*1.1, center=true);
      }
      translate([-mp_x3/2, mp_y3-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=mp_wall*1.1, center=true);
      }
      translate([0, mp_y4-mp_h/2, mp_wall/2]){
        cylinder(d=M4_hole, h=mp_wall*1.1, center=true);
      }
    }
  }
  
}

module bowl(){
  b_d = bowl_d;
  b_h = bowl_h;
  b_h2 = b_h + 1;
  b_wall = bowl_wall;
  b_enf_w = 70;// 2 * mm_r + 10;
  bottom_hole = 6;
  bottom_cylinder =45;
  wall_w=10;
  tip_cut = 1;
  mount_d1 = 15;
  mount_d2 = 30;
  mount_h = 5;
  mm_shift = 22;
  mm_enf_d = 40;
  mm_enf_h = 15;
  alu_tol = 0.7;
  alu_cut = 5;
  mount_edge = alu_cut + 52;
  rear_cut = 0;
  
  difference(){
    translate([0, 0, b_h/2]){
      union(){
        cylinder(d1=b_d, d2=bottom_hole+2*b_wall, h=b_h, center=true);
        translate([0, (alu_edge+alu_tol+b_wall)/2, (b_h2-b_h)/2]){
          cube(size=[b_d, b_wall, b_h2], center=true);
        }
        translate([0, -(alu_edge+alu_tol+b_wall)/2,  (b_h2-b_h)/2]){
          cube(size=[b_d, b_wall, b_h2], center=true);
        }
        translate([0, 0,  (b_h2-b_h-alu_cut)/2]){
          cube(size=[b_enf_w, alu_edge+alu_tol, b_h2-alu_cut], center=true);
        }
        //cylinder(d=bottom_cylinder, h=b_h, center=true);
      }
    }
    //Cut inner cone
    translate([0, 0, b_h/2-b_wall]){
      difference(){
        cylinder(d1=b_d, d2=bottom_hole+2*b_wall, h=b_h, center=true);
        //Rear cut
        translate([0, -(b_d+alu_edge+alu_tol)/2-rear_cut, 0]){
          cube(size=[b_d, b_d, b_h2], center=true);
        }
        //Cut motor mount holes
        translate([mm_r, 0, 0]){
          rotate([0, 0, 0]){
            cylinder(d=M3_hole*4, h=b_h2, center=true);
          }
        }
        translate([-mm_r, 0, 0]){
          rotate([0, 0, 0]){
            cylinder(d=M3_hole*4, h=b_h2, center=true);
          }
        }
      }
    }
    //Cut rear
    translate([0, -(b_d+alu_edge+alu_tol)/2-b_wall-rear_cut, b_h2/2]){
      cube(size=[b_d, b_d, b_h2*1.1], center=true);
    }
    //Cut bottom hole
    translate([0, 0, b_h-b_wall/2]){
      cylinder(d=16, h=200, center=true);
    }
    //Cut motor mount holes
    translate([mm_r, 0, 0]){
      rotate([0, 0, 0]){
        cylinder(d=M4_hole, h=2*b_h2, center=true);
      }
    }
    translate([-mm_r, 0, 0]){
      rotate([0, 0, 0]){
        cylinder(d=M4_hole, h=2*b_h2, center=true);
      }
    }
    //Cut motor mount holes
    translate([mm_r, 0, b_h2]){
      rotate([0, 0, 0]){
        cylinder(d=8, h=30, center=true);
      }
    }
    translate([-mm_r, 0, b_h2]){
      rotate([0, 0, 0]){
        cylinder(d=8, h=30, center=true);
      }
    }
/*    
    //Cut alu bar mount holes
    translate([mount_d1, 0, b_h2-mount_h]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=b_d, center=true);
      }
    }
    translate([mount_d2, 0, b_h2-mount_h]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=b_d, center=true);
      }
    }
    translate([-mount_d1, 0, b_h2-mount_h]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=b_d, center=true);
      }
    }
    translate([-mount_d2, 0, b_h2-mount_h]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=b_d, center=true);
      }
    }
*/       
    //Upper mount hole
    translate([0, -b_d/2, b_h2-mount_edge]){
      rotate([90, 0, 0]){
        cylinder(d=M4_hole, h=b_d, center=true);
      }
    }
  }
  
  
  
}

module roundedRect(size, radius, edges=[1, 1, 1, 1]){
  x = size[0];
  y = size[1];
  z = size[2];

  linear_extrude(height=z){
    hull(){
        // place 4 circles in the corners, with the given radius
        if(edges[0]){
          translate([(-x/2)+(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
        if(edges[1]){
          translate([(x/2)-(radius), (-y/2)+(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (-y/2)+(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[2]){
          translate([(-x/2)+(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(-x/2)+(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }

        if(edges[3]){
          translate([(x/2)-(radius), (y/2)-(radius), 0])
          circle(r=radius);
        }
        else{
          translate([(x/2)-(radius/2), (y/2)-(radius/2), 0])
          square(size=[radius, radius], center=true);
        }
    }
  }
}